.TH xnetstats 1
.SH NAME
.PP
xnetstats \- an x-based front end for netstat -i

.SH SYNOPSIS
.PP
\f3xnetstats\f1 [\f3-c \f2colormode\f1] 
[\f3-h\f1] 
[\f3-u\f2 update interval\f1] 

.SH DESCRIPTION
.PP

\fIxnetstats\fP is an x-based front end for netstat -i, which displays
input and output packets, input and output errors and collisions per
second.  For more information about these figures consult the manual
page of netstat(1).

For each of these figures a chart with a header is drawn. The header
consists of a title and a number which indicates the scale on the
chart. If the scale is 100 and the value which is to visualize amounts
to 350 three horizontal rulers are drawn and the displayed values are
scaled accordingly. If the  scale is 2 and the the value to be
displayed is 1, the visualized data fills 50 percent of the height.

.SH OPTIONS
.PP
In addition to the standard toolkit options such as
-display, -name, -geometry, -iconic, -xrm etc. (see manual page X)
xnetstats accepts  the following options:
.TP
\f3-c \f2colormode\f1
start xnetstats using the given color-mode (for details see manual page
wafeapp); color modes are for example \fImono\fP, \fIblueish\fP or \fIwheat-ish\fP.

.TP
\f3-h\f1
show a short usage message.

.TP
\f3-u \f2update interval\f1
used to specify a non-default interval in seconds, 
in which the charts are updated. The default update interval is 5 seconds.

.SH "KEY BINDINGS"
.PP
.TP 13
<Key>q
quits the application

.SH "ENVIRONMENT VARIABLES"
.PP
.TP 13
WAFELIB
location of the wafe library (typically /usr/lib/X11/wafe)

.SH "PERL VARIABLES"
.PP
Wafe (Perl-) Variables from $WAFELIB/system.waferc or $HOME/.waferc:
.TP 13
$backGround
back ground color
.TP
$roColors
attributes for charts
.TP
$sbColors
background color of $sbColors is used for horizontal rulers of charts

.SH FILES 
.PP
.EX 0
$WAFELIB/system.waferc
$HOME/.waferc
.EE
.SH "SEE ALSO"
.PP
netstat(1),
wafe(n),
wafeapp(n),
X(1),
xwafemail(n),
xwafenews(n),
xwafeftp(n),
xwafeora(n),
xwafetel(n),
xdirtree(n),
xdirtree(n),
xprojektor(n),
xbm(n),
xwafemc(n),
xruptimes(n),
xnetstats(n),
xvmstats(n),
xwafeping(n),
xwafecf(n)

.SH COPYRIGHT
.PP
 Copyright (C) 1992 by Gustaf Neumann, Stefan Nusser
.EX 0
     Wirtschaftsuniversitaet Wien, 
     Abteilung fuer Wirtschaftsinformatik
     Augasse 2-6, 
     A-1090 Vienna, Austria
     neumann@wu-wien.ac.at, nusser@wu-wien.ac.at
.EE
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appears in all copies and that both that
copyright notice and this permission notice appear in all supporting
documentation.  This software is provided "as is" without expressed or
implied warranty.
.PP
.SH AUTHORS
.PP
Gustaf Neumann, Stefan Nusser
