.TH xruptimes 1
.SH NAME
.PP
xruptimes \- an x-based front end for ruptime (remote uptime)

.SH SYNOPSIS
.PP
\f3xruptimes\f1 
[\f3-u\f2 update interval\f1] 
[host1 [host2 [...]]]

.SH DESCRIPTION
.PP

\fIxruptimes\fP is an x-based front end for ruptime and displays
the load for the hosts in the argument list. To use this program 
ruptime (see manual page ruptime(1)) must be working on your system and
provide meaningful data. The program ruptime collects data of the rwho
daemon (see manual pages rwho(1) and rwhod(8)).

For each host in the argument list a chart is drawn with a header
containing the host name. Each chart represents the load of the
corresponsing host. If the load is higher than 1 horizontal rulers are
displayed.

.SH OPTIONS
.PP
In addition to the standard toolkit options such as
-display, -name, -geometry, -iconic, -xrm etc. (see manual page X)
xruptimes accepts  the following option:

.TP 
\f3-u \f2update interval\f1 
used to specify a non-default interval
in seconds, in which the charts are updated. The default update
interval is 90 seconds. The update interval of the rwho daemon is
typically 180 seconds.

If no arguments for hosts to be monitored are given, only the load of
the local host is displayed.

.SH "KEY BINDINGS"
.PP
.TP 13
<Key>q
quits the application

.SH "ENVIRONMENT VARIABLES"
.PP
.TP 13
WAFELIB
location of the wafe library (typically /usr/lib/X11/wafe)

.SH "PERL VARIABLES"
.PP
Wafe (Perl-) Variables from $WAFELIB/system.waferc or $HOME/.waferc:
.TP
$sbColors
background color of $sbColors is used for horizontal rulers of charts

.SH "SEE ALSO"
.PP
ruptime(1),
wafe(n),
wafeapp(n),
X(1),
xwafemail(n),
xwafenews(n),
xwafeftp(n),
xwafeora(n),
xwafetel(n),
xdirtree(n),
xdirtree(n),
xprojektor(n),
xbm(n),
xwafemc(n),
xruptimes(n),
xnetstats(n),
xiostats(n),
xvmstats(n),
xwafeping(n),
xwafecf(n)

.SH COPYRIGHT
.PP
 Copyright (C) 1992 by Gustaf Neumann, Stefan Nusser
.EX 0
     Wirtschaftsuniversitaet Wien, 
     Abteilung fuer Wirtschaftsinformatik
     Augasse 2-6, 
     A-1090 Vienna, Austria
     neumann@wu-wien.ac.at, nusser@wu-wien.ac.at
.EE
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appears in all copies and that both that
copyright notice and this permission notice appear in all supporting
documentation.  This software is provided "as is" without expressed or
implied warranty.
.PP
.SH AUTHORS
.PP
Gustaf Neumann, Stefan Nusser
