.TH xwafeping 1
.SH NAME
.PP
xwafeping \- an x-based front end for ping

.SH SYNOPSIS
.PP
\f3xwafeping\f1 [\f3-c \f2colormode\f1] 
[\f3-h\f1] 
[\f3-u\f2 update interval\f1] 
[host1] [host2] ...

.SH DESCRIPTION
.PP

\fIxwafeping\fP is an x-based front end for ping, which repeatedly determines for
each given host its reachability via TCP/IP.  If the host can be
reached an upward thumb is displayed, otherwise a thumb pointing down.
\fIxwafeping\fP uses the program ping (see manual page ping(1)) to
test the reachability.

For all given hosts the reachability is tested every 90 seconds. If
no host is given, default hosts (@ftpServers from
\fIxwafeftp\fP) are assumed.

.SH OPTIONS
.PP
In addition to the standard toolkit options such as
-display, -name, -geometry, -iconic, -xrm etc. (see manual page X)
xwafeping accepts  the following options:
.TP
\f3-c \f2colormode\f1
start xwafeping using the given color-mode (for details see manual page
wafeapp); color modes are for example \fImono\fP, \fIblueish\fP or \fIwheat-ish\fP.

.TP
\f3-h\f1
show a short usage message.

.TP
\f3-u \f2update interval\f1
used to specify a non-default interval in seconds, 
in which the charts are updated. The default update interval is 90 seconds.

.SH "KEY BINDINGS"
.PP
.TP 13
<Key>q
quits the application

.SH "ENVIRONMENT VARIABLES"
.PP
.TP 13
WAFELIB
location of the wafe library (typically /usr/lib/X11/wafe)

.SH "PERL VARIABLES"
.PP
Wafe (Perl-) Variables from $WAFELIB/system.waferc or $HOME/.waferc:
.TP 13
$backGround
back ground color

.SH FILES 
.PP
.EX 0
$WAFELIB/system.waferc
$HOME/.waferc
.EE
.SH "SEE ALSO"
.PP
ping(1),
wafe(n),
wafeapp(n),
X(1),
xwafemail(n),
xwafenews(n),
xwafeftp(n),
xwafeora(n),
xwafetel(n),
xdirtree(n),
xdirtree(n),
xprojektor(n),
xbm(n),
xwafemc(n),
xruptimes(n),
xnetstats(n),
xiostats(n),
xvmstats(n),
xwafeping(n),
xwafecf(n)

.SH COPYRIGHT
.PP
 Copyright (C) 1992 by Gustaf Neumann, Stefan Nusser
.EX 0
     Wirtschaftsuniversitaet Wien, 
     Abteilung fuer Wirtschaftsinformatik
     Augasse 2-6, 
     A-1090 Vienna, Austria
     neumann@wu-wien.ac.at, nusser@wu-wien.ac.at
.EE
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appears in all copies and that both that
copyright notice and this permission notice appear in all supporting
documentation.  This software is provided "as is" without expressed or
implied warranty.
.PP
.SH AUTHORS
.PP
Gustaf Neumann, Stefan Nusser
