.TH xwafegopher 1
.SH NAME
.PP
xwafegopher \- a simple x-based gopher client 

.SH SYNOPSIS
.PP
\f3xwafegopher\f1 [\f3-c \f2colormode\f1] 
[\f3-3\f1] 
[\f3-p \f2gopher port\f1] 
[\f3-s \f2gopher server\f1]

.SH DESCRIPTION
.PP

\fIxwafegopher\fP is a simple x-based gopher client which provides
access to the distributed gopher information system by connecting via
tcpip to a distant gopher server (default: gopher.micro.umn.edu).
xwafegopher is a \fIwafe\fP application (see manual page wafeapp)
written in Perl. 

.SH OPTIONS
.PP
In addition to the standard toolkit options 
such as -display, -name, -geometry, -iconic, -xrm etc. (see manual
page X) xwafegopher accepts the following options:
.TP
\f3-c \f2colormode\f1
start xwafegopher using the given color-mode (for details see manual page
wafeapp); color modes are for example \fImono\fP, \fIblueish\fP or \fIwheat-ish\fP.

.TP
\f3-3\f1
do not use 3 dimensional widgets. This option depends of the configuration 
in the system.waferc file (see manual page wafeapp).

.TP
\f3-p \f2gopher port\f1 
specify gopher port. The default value is 70.

.TP
\f3-s \f2gopher server\f1
specify name of gopher server. Per default gopher.micro.umn.edu 
is used.

.TP
\f3-h\f1
show a short usage message.

.SH "LAYOUT and INTERACTION" 

.PP 
When xwafegopher is started the user will see an X front end with
two main sections: a list of topics and a quit button and an information line.
Each item in the list of topics stats with an small symbol to distinguish
between text information, directories (lists of subtopics) and telnet based
information. The information will be retrieved by clicking with the 
left mouse button in the line of interest. If an directory was retrieved
an additional subwindow pop up, which has the same structure as the 
top level window. In the current implementation on each level at most one
subwindow can be displayed (except for telnet based services).
The \fIQuit\fP button of the top window terminates the application.

.SH "KEY BINDINGS"
.TP 13
<Btn1>
retrieve information
<Btn3>
Show source of information

.SH "ENVIRONMENT VARIABLES"
.PP
.TP 13
WAFELIB
location of the wafe library (typically /usr/lib/X11/wafe)

.SH "PERL VARIABLES"
.PP
Wafe (Perl-) Variables from $WAFELIB/system.waferc or $HOME/.waferc:
.TP 13
$defaultGopherHost
Name of the default gopher server
.TP 13
$boldFont
typically used for bold labels
.TP
$buttonFont
typically used as font for buttons
.TP
$buttonAtts
attributes used for buttons
.TP
$backGround
back ground color
.TP
$roColors
attributes for non emphasized text (typically colors)
.TP
$infoColors
attributes of the info line (typically colors)
.TP
@textActions
default actions for text widgets

.SH FILES 
.PP
.EX 0
$WAFELIB/system.waferc
$HOME/.waferc
.EE
.SH "SEE ALSO"
.PP
wafe(n),
wafeapp(n),
X(1),
xwafemail(n),
xwafenews(n),
xwafeftp(n),
xwafeora(n),
xwafetel(n),
xdirtree(n),
xdirtree(n),
xprojektor(n),
xbm(n),
xwafemc(n),
xruptimes(n),
xnetstats(n),
xiostats(n),
xvmstats(n),
xwafeping(n),
xwafecf(n)

.SH COPYRIGHT
.PP
 Copyright (C) 1992 by Gustaf Neumann, Stefan Nusser
.EX 0
    Wirtschaftsuniversitaet Wien, 
    Abteilung fuer Wirtschaftsinformatik
    Augasse 2-6, 
    A-1090 Vienna, Austria
    neumann@wu-wien.ac.at, nusser@wu-wien.ac.at
.EE
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appears in all copies and that both that
copyright notice and this permission notice appear in all supporting
documentation.  This software is provided "as is" without expressed or
implied warranty.
.PP
.SH AUTHORS
.PP
Gustaf Neumann, Stefan Nusser



