$PACKAGE = "ATHENA";

~handles
	ATHENA
	XAW3D
	XEDW 

#include "wafe.h"

~require
athena.inc
	quark callback
	quark jumpProc
	quark scrollProc

~widgetClass 
asciiText
	include <X11/Xaw/AsciiText.h>

#define asciiTextAppend(w,text) { String string, newString;\
     XtVaGetValues(w, XtNstring, &string, NULL); \
     if (string) { \
          newString = XtMalloc(strlen(string) + strlen(text) +2);\
          strcpy(newString, string); \
          strcat(newString, text);  \
     } else newString = XtNewString(text); \
     XtVaSetValues(w, XtNstring, newString, NULL); \
     XtFree(newString);}

Boolean
XawAsciiSave
	in: XawTextGetSource(AsciiTextWidget)	# ascii text wiget

int 
XawAsciiSaveAsFile
        in: XawTextGetSource(AsciiTextWidget)	# ascii text wiget
        in: String			        # file name

Boolean
XawAsciiSourceChanged 
	in: XawTextGetSource(AsciiTextWidget)	# ascii text wiget

void
XawAsciiSourceFreeString
	in: XawTextGetSource(AsciiTextWidget)	# ascii text wiget

void
asciiTextAppend
	in: AsciiTextWidget		# ascii text widget
	in: String			# string to append

~widgetClass 
box
	include <X11/Xaw/Box.h>

~widgetClass 
clock
	include <X11/Xaw/Clock.h>

~widgetClass 
command
	include <X11/Xaw/Command.h>

~widgetClass 
dialog
	include <X11/Xaw/Dialog.h>

String
XawDialogGetValueString
	in: DialogWidget		# dialog widget

~widgetClass 
form
	include <X11/Xaw/Form.h>

#ifdef XEDW

#include "Xedw/XedwList.h"

hint: XEDW
~require
	edwlist.inc

hint: XEDW,noDoc
~widgetClass
xedwList vulgo edwList

hint: XEDW,noDoc
void
edwListChange
	in: Widget			# list widget
	const: argv[1]
	in: int				# number of items
	in: int				# longest
	in: int				# resize
	in: [args odd]			# Arg items 

hint: XEDW,noDoc
XedwListReturnStruct *
XedwListShowCurrent
	in: Widget			# edw list widget

#endif

void
XawFormDoLayout
	in: FormWidget			# form widget
	in: Boolean			# boolean

~widgetClass 
grip
	include <X11/Xaw/Grip.h>

~widgetClass 
label
	include <X11/Xaw/Label.h>

~widgetClass 
list
	include <X11/Xaw/List.h>
	createCmd listCreate
	callback i int: ((XawListReturnStruct *)callData)->list_index \
		# index
	callback s EscapedString: ((XawListReturnStruct *)callData)->string  \
		# selection

void
listAppend
	in: ListWidget			# list widget
	in: [args]			# items 

void
listChange
	in: ListWidget			# list widget
	const: argv[1]
	in: int				# number of items
	in: int				# longest
	in: int				# resize
	in: [args]			# Arg items | File filename

void
XawListHighlight
	in: ListWidget			# list widget
	in: int				# item number

XawListReturnStruct *
XawListShowCurrent
	in: ListWidget			# list widget


void
XawListUnhighlight
	in: ListWidget			# list widget

~widgetClass 
logo
	include <X11/Xaw/Logo.h>

~widgetClass 
mailbox
	include <X11/Xaw/Mailbox.h>

~widgetClass 
menuButton
	include <X11/Xaw/MenuButton.h>

~widgetClass 
paned
	include <X11/Xaw/Paned.h>

void
XawPanedAllowResize
	in: PanedWidget			# paned widget
	in: Boolean			# boolean

void
XawPanedGetMinMax
	in: PanedWidget			# paned widget
	out: int			# min
	out: int			# max

int
XawPanedGetNumSub
	in: PanedWidget			# paned widget

void
XawPanedSetMinMax
	in: PanedWidget			# paned widget
	in: int				# min
	in: int				# max

void 
XawPanedSetRefigureMode
	in: PanedWidget			# paned widget
	in: Boolean			# boolean

~widgetClass 
scrollbar
	include <X11/Xaw/Scrollbar.h>
	createCmd scrollbarCreate
	scrollProc p int: (int)callData		# position of thumb (in pixel)
	jumpProc p float: *(float *)callData	# floating position (0.0-1.0)

void
XawScrollbarSetThumb
	in: ScrollbarWidget		# scrollbar widget
	in: float			# top
	in: float			# shown

~alias
	scSet stripChartSet

~widgetClass 
simple
	include <X11/Xaw/Simple.h>

~widgetClass 
simpleMenu
	include <X11/Xaw/SimpleMenu.h>
	createCmd XtCreatePopupShell
	createsShell

void 
XawSimpleMenuClearActiveEntry
	in: SimpleMenuWidget		# widget

Widget
XawSimpleMenuGetActiveEntry
	in:SimpleMenuWidget		# widget

~objectClass 
sme
	include <X11/Xaw/Sme.h>

~objectClass 
smeBSB
	include <X11/Xaw/SmeBSB.h>

~objectClass 
smeLine
	include <X11/Xaw/SmeLine.h>

~widgetClass 
stripChart
	include <X11/Xaw/StripChart.h>
	createCmd stripChartCreate

void
stripChartSet
	in: StripChartWidget		# strip chart widget
	in: double			# value

void
XawTextDisableRedisplay
	in: AsciiTextWidget		# ascii text wiget

void
XawTextDisplay
	in: AsciiTextWidget		# ascii text wiget

void
XawTextDisplayCaret
	in: AsciiTextWidget		# ascii text wiget
	in: Boolean			# boolean

void
XawTextEnableRedisplay
	in: AsciiTextWidget		# ascii text wiget

XawTextPosition
XawTextGetInsertionPoint
	in: AsciiTextWidget		# ascii text wiget

void 
XawTextGetSelectionPos
        in: AsciiTextWidget 		# ascii text wiget
        out: XawTextPosition		# varname for from position
        out: XawTextPosition 		# varname for to position

void
XawTextInvalidate
	in: AsciiTextWidget		# ascii text wiget
	in: XawTextPosition		# from postion
	in: XawTextPosition		# to postion

XawTextPosition
XawTextSearch
	in: AsciiTextWidget		# ascii text wiget
	in: XawTextScanDirection	# scan direction
	in: XawTextBlock		# text block

void
XawTextSetInsertionPoint
	in: AsciiTextWidget		# ascii text wiget
	in: XawTextPosition		# position

void 
XawTextSetSelection
        in: AsciiTextWidget 		# ascii text wiget
        in: XawTextPosition		# from position
        in: XawTextPosition 		# to position

void
XawTextSetSelectionArray
	in: AsciiTextWidget		# ascii text wiget
	in: [XawTextSelectType]		# selction array


int
XawTextSinkMaxHeight
	in: (Widget)TextSink 		# ascii text wiget
	in: int				# height

int
XawTextSinkMaxLines
	in: (Widget)TextSink		# ascii text wiget
	in: Dimension			# height

void
XawTextSinkSetTabs
	in: (Widget)TextSink		# ascii text wiget
	const: argc-2
	in: [int]			# tabs

XawTextPosition
XawTextSourceRead 
	in: (Widget)TextSource		# ascii text wiget
	in: XawTextPosition		# position
	out: XawTextBlock		# varname for text block
	in: int				# length

XawTextPosition
XawTextSourceScan
	in: (Widget)TextSource		# ascii text wiget
	in: XawTextPosition		# position
	in: XawTextScanType		# scan type
	in: XawTextScanDirection	# scan direction
	in: int				# count
	in: Boolean			# include (boolean)

XawTextPosition
XawTextTopPosition
	in: AsciiTextWidget		# ascii text wiget

(int) ReplaceVal 
XawTextReplace
        in: AsciiTextWidget		# ascii text wiget
        in: XawTextPosition 		# from position
        in: XawTextPosition 		# to position
        in: XawTextBlock		# text block

void 
XawTextUnsetSelection
        in: AsciiTextWidget 		# ascii text wiget

~widgetClass 
toggle
	include <X11/Xaw/Toggle.h>

void
XawToggleChangeRadioGroup
	in: ToggleWidget		# toggle widget
	in: NULL | ToggleWidget		# NULL | toggle widget

String
XawToggleGetCurrent
	in: ToggleWidget		# toggle widget

void
XawToggleSetCurrent
	in: ToggleWidget		# toggle widget
	in: String			# radio data

#define toggleSetRadioData(w, string) \
	XtVaSetValues(w, XtNradioData, string, NULL)

void
toggleSetRadioData
	in: ToggleWidget		# toggle widget
        in: XtNewString(String)		# radio data

void
XawToggleUnsetCurrent
	in: ToggleWidget		# toggle widget

~widgetClass 
viewport
	include <X11/Xaw/Viewport.h>

hint: R5
void
XawViewportSetCoordinates
	in: ViewportWidget		# viewport Widget
	in: Position			# x position
	in: Position			# y position

hint: R5
void
XawViewportSetLocation
	in: ViewportWidget		# viewport Widget
	in: double			# xoffset 
	in: double			# yoffset

